import 'dart:convert';

import 'package:click_extensions/click_extensions.dart';

abstract class RequestMapping {
  Map<String, dynamic> data;

  RequestMapping.empty() : data = {};

  RequestMapping.fromJson(String dataRequest) : data = jsonDecode(dataRequest) {
    fromMap();
  }

  RequestMapping.fromMap(Map<String, dynamic> map) : data = map {
    fromMap();
  }

  void validate();
  void fromMap();
  Map<String, dynamic> toMap();

  String toIni([int? itemNumber]) {
    String result = '';
    toMap().forEach((key, value) {
      if (value != null) result += '${key.toCapitalize}=$value\n';
    });

    if (result == '') {
      return '';
    } else {
      if (itemNumber == null) {
        return '[$runtimeType]\n$result';
      } else {
        return '[$runtimeType${itemNumber.toString().padLeft(3, '0')}]\n$result';
      }
    }
  }

  String toJson() {
    try {
      return json.encode(toMap());
    } catch (e) {
      print(e);
      rethrow;
    }
  }
}
